proc s10_write_reg {m base_addr offset bitmask newval} {

#  global m;
#  global base_addr;

  #read from data register
  set value [master_read_8 $m [expr $base_addr + $offset * 4] 1]

  # bitwise-AND to clear out bitmask bits
  set value [expr $value & [expr 0xff & ~$bitmask]] 

  # bitwise-OR enable bits
  #set value [expr $value | $newval] 
  
  set value [expr $value | [expr $newval & $bitmask]] 
  

  master_write_8 $m [expr $base_addr + $offset * 4] $value

}

proc s10_read_reg {m base_addr offset } {

#  global m;
#  global base_addr;

  #read from data register
  set value [master_read_8 $m [expr $base_addr + $offset * 4] 1]

}


proc s10_write_reg_32 {m base_addr offset bitmask newval} {

#  global m;
#  global base_addr;

  #read from data register
  set value [master_read_32 $m [expr $base_addr + $offset * 4] 1]

  # bitwise-AND to clear out bitmask bits
  set value [expr $value & [expr 0xffffffff & ~$bitmask]] 

  # bitwise-OR enable bits
  #set value [expr $value | $newval] 
  
  set value [expr $value | [expr $newval & $bitmask]] 
  

  master_write_32 $m [expr $base_addr + $offset * 4] $value

}



proc s10_read_reg_32 {m base_addr offset } {

#  global m;
#  global base_addr;

  #read from data register
  set value [master_read_32 $m [expr $base_addr + $offset * 4] 1]

}